package xic;

import edu.cornell.cs.cs4120.xi.Position;

/**
 * Internal compiler exception - thrown to indicate serious errors 
 * in the program logic.
 */
public class InternalCompilerException extends RuntimeException {
	private static final long serialVersionUID = -1283533320776676348L;
	private Position position;

	public InternalCompilerException(String message) {
    	super(message);
    }

    public InternalCompilerException(String message, Exception e) {
    	super(message, e);
    }

	public InternalCompilerException(String message, Position position) {
    	super(message);
    	this.position = position;
    }

    public InternalCompilerException(String message, Exception e, Position position) {
    	super(message, e);
    	this.position = position;
    }

    /**
     * Return associated source position information -- may be null!
     */
    public Position getPosition() {
		return position;
	}
}
