package xic;

import edu.cornell.cs.cs4120.xi.Position;


public class PositionImpl implements MutablePosition {
	private String unit;
	private int lineStart, lineEnd, columnStart, columnEnd;
	
	public PositionImpl() {
		unit = "unknown";
		lineStart = lineEnd = columnStart = columnEnd = -1;
	}

	public PositionImpl(String unit, int lineStart, int lineEnd,
			int columnStart, int columnEnd) {
		this.unit = unit;
		this.lineStart = lineStart;
		this.lineEnd = lineEnd;
		this.columnStart = columnStart;
		this.columnEnd = columnEnd;
	}
	
	public PositionImpl(Position position) {
		this.unit = position.unit();
		this.lineStart = position.lineStart();
		this.lineEnd = position.lineEnd();
		this.columnStart = position.columnStart();
		this.columnEnd = position.columnEnd();
	}

	public void setColumnEnd(int columnEnd) {
		this.columnEnd = columnEnd;
	}

	public int columnEnd() {
		return columnEnd;
	}

	public void setColumnStart(int columnStart) {
		this.columnStart = columnStart;
	}

	public int columnStart() {
		return columnStart;
	}

	public void setLineStart(int lineStart) {
		this.lineStart = lineStart;
	}

	public int lineStart() {
		return lineStart;
	}

	public void setLineEnd(int lineEnd) {
		this.lineEnd = lineEnd;
	}

	public int lineEnd() {
		return lineEnd;
	}

	public String unit() {
		return unit;
	}

	public void setUnit(String unit) {
		this.unit = unit;
	}

	public boolean equals(Object obj) {
		if (obj.getClass() != PositionImpl.class)
			return false;
		PositionImpl other = (PositionImpl) obj;
		return (other.unit.equals(unit) && other.lineStart == lineStart
			&& other.lineEnd == lineEnd
			&& other.columnStart == columnStart
			&& other.columnEnd == columnEnd);
	}

	public int hashCode() {
		int result = 17;
		result = 37*result + unit.hashCode();
		result = 37*result + lineStart;
		result = 37*result + lineEnd;
		result = 37*result + columnStart;
		result = 37*result + columnEnd;
		return result;
	}

	public String toString() {
		if (lineStart == lineEnd) {
			if (columnStart == columnEnd)
				return (lineStart+1) + "," + (columnStart+1);
			else
				return (lineStart+1) + "," + (columnStart+1) + "-"
						+ columnEnd;
		}
		return (lineStart+1) + "," + (columnStart+1) + "-" + (lineEnd+1)
				+ "," + (columnEnd+1);
	}
}
