package xic.ast;

import xic.ErrorSink;
import xic.visitors.NodeVisitor;
import edu.cornell.cs.cs4120.xi.CompilationException;
import edu.cornell.cs.cs4120.xi.Position;

public class UnitType extends TypeNode {
	/* Static types without position information */
	public static final UnitType UNIT_TYPE =
		new UnitType(null);
	
	/**
	 * "Unit" type
	 */
	public UnitType(Position pos) {
			super(pos);
	}

	public String label() {
			return "unitType";
	}
	
	public boolean isSubtypeOf(TypeNode node) {
		return node instanceof UnitType;
	}
	
	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}

	public Copyable copy() {
		return new UnitType (position);
	}

	public boolean isIdenticalType(TypeNode node) {
		return node instanceof UnitType;
	}

	public String toString() {
		return "unit";
	}
	
	public int size() {
		throw new UnsupportedOperationException("UnitType.size()");
	}
	
	public void match(TypeNode node, ErrorSink sink) {
		if (!(node instanceof UnitType))
			sink.addError(new CompilationException("Unmatched type, excepted: "
					+this.label()+", got: "+node.label(), node.position()));
	}
}