package xic.codegen;

import java.util.ArrayList;
import java.util.List;

public abstract class AbstractTile implements Tile {
	protected int cost = -1;
	protected List<Tile> children;
	
	public AbstractTile() {
		children = new ArrayList<Tile>();
	}
	
	public int estimateCost() {
		if (cost != -1)
			return cost;
		
		cost = 0;
		for (Tile t : children)
			cost += t.estimateCost();
		
		cost += localCost();
		return cost;
	}

	protected abstract int localCost();
}
