package xic.codegen;

import xic.ir.NameGenerator;

/**
 * Stores information about a potential tile used
 * during the code generation process.
 */
public interface Tile {
	/**
	 * Returns the approximate number of execution
	 * cycles.
	 */
	int estimateCost();

	/**
	 * Turns this tile and its children into a
	 * sequence of abstract machine-level 
	 * instructions and adds it to the given instruction
	 * list. A name generator is required to generate
	 * temporary variables for parameter passing.
	 * @return
	 * 		The name of a temporary containing the
	 * 		result. Null if there is no result.
	 */
	String translate(InstrList il, NameGenerator ng);
}
