package xic.codegen.matchers;

import xic.codegen.AbstractTile;
import xic.codegen.Instr;
import xic.codegen.InstrList;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRDecl;
import xic.ir.IRNode;
import xic.ir.NameGenerator;

public class DeclMatcher implements Matcher {
	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRDecl))
			return null;

		final String name = ((IRDecl) node).name();
		return new AbstractTile() {
			public String translate(InstrList il, NameGenerator ng) {
				il.add(new Instr("declare", new Instr.Op(Instr.Op.Type.REG, name)));
				return null;
			}
			
			protected int localCost() {
				return 0;
			}
		};
	}
}
