package xic.codegen.matchers;

import xic.codegen.InstrList;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRNode;
import xic.ir.IRTemp;
import xic.ir.NameGenerator;

public class TempMatcher implements Matcher {
	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRTemp))
			return null;

		final String name = ((IRTemp) node).name();
		return new Tile() {
			public int estimateCost() {
				return 0;
			}
			
			public String translate(InstrList il, NameGenerator ng) {
				return name;
			}

			public String toString() {
				return name;
			}
		};
	}
}
