package xic.lexer;

import edu.cornell.cs.cs4120.xi.Position;

public class StringToken extends BaseToken {
	private String stringValue;

	public StringToken(int type, Position position,  String value, String stringValue) {
		super(type, position, value);
		this.stringValue = stringValue;
	}

	public String stringValue() {
		return stringValue;
	}

	public boolean equals(Object obj) {
		if (obj.getClass() != StringToken.class)
			return false;
		StringToken other = (StringToken) obj;
		return super.equals(other) && other.stringValue.equals(stringValue);
	}

	public int hashCode() {
		return 37*super.hashCode() + stringValue.hashCode();
	}
}
